/*! \file OptionChar.h 
 *  \brief: header file for optionchar object
 */

#ifndef _OPTIONCHAR_H_
#define _OPTIONCHAR_H_

/*Headers:{{{*/
#include "../../../include/include.h"
#include "../../../shared/Exceptions/exceptions.h"
#include "../../../EnumDefinitions/EnumDefinitions.h"

#include "./Option.h"
/*}}}*/

class OptionChar: public Option {

	public:

		char* values;

		/*OptionChar constructors, destructors {{{*/
		OptionChar();
		~OptionChar();
		/*}}}*/
		/*Object virtual functions definitions:{{{*/
		void  Echo();
		void  DeepEcho();
		void  DeepEcho(char* indent);
		int   Id(){_error2_("Not implemented yet");};
		int   MyRank(){_error2_("Not implemented yet");};
		int   ObjectEnum(){return OptionCharEnum;};
		Object* copy(){_error2_("Not implemented yet");};
		/*}}}*/

		/*virtual functions: */
		char* Name();
		int   NumEl();
		int   NDims();
		int*  Size();
		void  Get(int* pvalue){_error2_("An OptionChar object cannot return a int");};
		void  Get(IssmDouble* pvalue){_error2_("An OptionChar object cannot return a IssmDouble");};
		void  Get(bool* pvalue){  _error2_("An OptionChar object cannot return a bool");};
		void  Get(char** pvalue);
		void  Get(char*** ppvalue,int *pnumel);
		void  Get(IssmDouble** pvalue,int *pnumel){ _error2_("An OptionChar object cannot return a IssmDouble vec");};
		void  Get(Options** pvalue){ _error2_("An OptionChar object cannot return an Options DataSet");};
		void  Get(Options*** ppvalue,int *pnumel){ _error2_("An OptionChar object cannot return an Options DataSet vec");};

};
#endif  /* _OPTIONCHAR_H */

